=== lib/jose/CMakeLists.txt ===
#
# libwebsockets - small server side websockets and web server implementation
#
# Copyright (C) 2010 - 2020 Andy Green <andy@warmcat.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#

include_directories(. ./jwe ./jws ./jwk)

if (LWS_WITH_JOSE)
	list(APPEND SOURCES
		jose/jwk/jwk.c
		jose/jws/jose.c
		jose/jws/jws.c
		jose/jwe/jwe.c
		jose/jwe/enc/aescbc.c
		jose/jwe/enc/aesgcm.c
		jose/jwe/enc/aeskw.c
		jose/jwe/jwe-rsa-aescbc.c
		jose/jwe/jwe-rsa-aesgcm.c
		jose/jwe/jwe-ecdh-es-aeskw.c
		)
endif()

#
# Keep explicit parent scope exports at end
#

exports_to_parent_scope()
