=== debian/changelog ===
libwebsockets (4.1.6-3) unstable; urgency=medium

  * Update self-testing.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 07 Aug 2022 10:46:31 +0200

libwebsockets (4.1.6-2) unstable; urgency=medium

  * Update -dev dependency.
  * Upload to Sid.

  [ Simon Chopin <simon.chopin@canonical.com> ]
  * d/rules: downgrade deprecation errors into warnings to fix the build
    against OpenSSL3 (closes: #1006245).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 06 Aug 2022 07:42:00 +0200

libwebsockets (4.1.6-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 11 Dec 2020 17:00:18 +0100

libwebsockets (4.1.4-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 29 Oct 2020 22:44:45 +0100

libwebsockets (4.1.3-1) experimental; urgency=medium

  * New upstream release.
  * Update library symbols for this release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 14 Oct 2020 18:05:17 +0200

libwebsockets (4.1.2-1) experimental; urgency=medium

  * New upstream release:
    - package ev, uv and glib event loops as plugins.
  * Library transition from libwebsockets16 to libwebsockets17 .
  * Update library symbols for this release.
  * Update debhelper level to 12 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 27 Sep 2020 17:53:20 +0200
